#include <stdio.h>
#include <signal.h>
#include <sys/socket.h>
#include <linux/if_ether.h>
#include <linux/in.h>
#include <linux/ip.h>
#include <linux/tcp.h>
#include "echo_server.h"
#include <sys/ioctl.h>
#include <linux/if.h>
#include <stdlib.h>
/*
 *   buff     .
 *  ETH_FRAME_LEN     Ethernet (1514)
 *    <linux/if_ether.h>
 */
 __u8 buff[ETH_FRAME_LEN];
 __u8 buff_send[ETH_FRAME_LEN];

/*
 * ,      SIGINT.
 *    -    SIGINT   
 *  "Promiscuous mode"   
 */
void mode_off()
{
    if(getifconf("eth0", &ifp, PROMISC_MODE_OFF) < 0) {
        perror("getifconf: ");
        exit(-1);
    }

    return;
}
/*
 *  
 */
int main(int argc,char  *argv[])
{
    __u32 num = 0;
   
    int send_socket;
    int res;
    int eth0_if, rec = 0, ihl = 0;
    struct iphdr ip; //    IP  
    struct tcphdr tcp; // TCP 
    struct ethhdr eth; //  Ethernet-
    static struct sigaction act;

    //    
    struct iphdr ip_send;
    struct tcphdr tcp_send;
//    struct ethhdr eth_send;
    struct sockaddr_in addr;
    char ip1,ip2,ip3,ip4;
    int i;
    int flag;
    int fd;
    struct ifreq ifr;
    unsigned char my_mac[6];
    FILE *fp;
 /*
 *     eth0   
 *   
 * 
 */
    flag=0;
   //  
   if (argc==2) 
   {
	printf("  ECHO-    : %s\n",argv[1]);
	if ((fp=fopen(argv[1],"w"))==NULL)
			printf("  ");
			else flag=1;
   } 

    if(getifconf("eth0", &ifp, PROMISC_MODE_ON) < 0) {
        perror("getifconf: ");
        return -1;
    }
   //  MAC-
    fd=socket(AF_INET,SOCK_DGRAM,0);
    memset(&ifr,0,sizeof(struct ifreq));
    memcpy(ifr.ifr_name,"eth0",4);
    ioctl(fd,SIOCGIFHWADDR,&ifr);
    //~ MAC-   my_mac
    memcpy(my_mac,(char *)&(ifr.ifr_hwaddr.sa_data),sizeof(struct sockaddr));


	    
/*
 *     
 */
//   printf("IP  - %s\n",inet_ntoa(ifp.ip));
//   printf("  - %s\n",inet_ntoa(ifp.mask));
//   printf("MTU - %d\n", ifp.mtu);
//   printf(" - %d\n", ifp.index);
if (flag) fprintf(fp,"\t\t\nECHO-server !!!\n\n");
printf("\t\t\nECHO-server !!!\n\n");
/*
 *    
 */
    if((eth0_if = getsock_recv(ifp.index)) < 0) {
        perror("getsock_recv:");
        return -1;
    }
/*
 *     SIGINT -  mode_off
 */
    act.sa_handler = mode_off;
    sigfillset(&(act.sa_mask));
    sigaction(SIGINT, &act, NULL);

/*
 *     
 */
    for(;;) {

        memset(buff, 0, ETH_FRAME_LEN); 
        rec = recvfrom(eth0_if, (char*)buff, ifp.mtu + 18, 0, NULL, NULL); 
	 if(rec < 0 || rec >ETH_FRAME_LEN) {
	               perror("recvfrom: ");
		       return -1;        
	};  
	//   IP  (  Ethernet)
	memset(buff_send,0,rec-14);
        memcpy((void *)&buff_send,buff+14,rec-14);
	       
	 //  
       memcpy((void *)&eth, buff, ETH_HLEN);
       memcpy((void *)&ip, buff + ETH_HLEN, sizeof(struct iphdr));
       memcpy((void *)&ip_send, buff_send, sizeof(struct iphdr));
       if((ip.version) != 4) continue;
       memcpy((void *)&tcp, buff + ETH_HLEN+ ip.ihl * 4, sizeof(struct tcphdr));
       memcpy((void *)&tcp_send, buff_send + ip_send.ihl * 4, sizeof(struct tcphdr));
                                                                 

/*                                                                                                     
 *  MAC-     MAC-,     
*/ 
       
       if ((eth.h_source[0]==my_mac[0]) && (eth.h_source[1]==my_mac[1]) && (eth.h_source[2]==my_mac[2]) &&
        (eth.h_source[3]==my_mac[3]) && (eth.h_source[4]==my_mac[4]) && (eth.h_source[5]==my_mac[5]))
       {
	
	 continue;
       }
        //printf("MAC () %.2x:%.2x:%.2x:%.2x:%.2x:%.2x\t",
        //eth.h_dest[0],eth.h_dest[1],eth.h_dest[2],
        //eth.h_dest[3],eth.h_dest[4],eth.h_dest[5]);
	
	//printf("MAC () %0.2x:%0.2x:%0.2x:%0.2x:%0.2x:%0.2x\n",
	//my_mac[0],my_mac[1],my_mac[2],my_mac[3],my_mac[4],my_mac[5]);

	      
/*
 *  IP-     
 */
        ip_send.saddr=ip.daddr;
        ip_send.daddr=ip.saddr;
			      
	//   
	if (ip_send.daddr==ifp.ip) {
		//printf("   \n");
                continue;
		};		
	        //   
	if (flag)
	        fprintf(fp," : \t%d.%d.%d.%d\t%d.%d.%d.%d\n ",buff_send[12],buff_send[13],buff_send[14],buff_send[15],buff_send[16],buff_send[17],buff_send[18],buff_send[19]);
	else
		printf(" : \t%d.%d.%d.%d\t%d.%d.%d.%d\n ",buff_send[12],buff_send[13],buff_send[14],buff_send[15],buff_send[16],buff_send[17],buff_send[18],buff_send[19]);
			        
	//   IP    
	ip1 = buff_send[12];	
        ip2 = buff_send[13];
        ip3 = buff_send[14];
 	ip4 = buff_send[15];

	buff_send[12] = buff_send[16];
	buff_send[13] = buff_send[17];
	buff_send[14] = buff_send[18];
	buff_send[15] = buff_send[19];

	buff_send[16] = ip1;
	buff_send[17] = ip2;
	buff_send[18] = ip3;
	buff_send[19] = ip4;
	//   
	inet_aton(inet_ntoa(ip_send.daddr),&addr.sin_addr);
        addr.sin_family=AF_INET;
	// 
	send_socket = socket(AF_INET,SOCK_RAW,IPPROTO_RAW);
	// echo-	
       if ((rec>0) &&(rec<ETH_FRAME_LEN)) {
               	res=sendto(send_socket,buff_send,rec-14,0,(struct sockaddr *)&addr,sizeof(addr));
		if (res==0)
			{
			if (!flag) perror("  :\n ");
		    	} else {
			if (flag) fprintf(fp," : \t%d.%d.%d.%d\t%d.%d.%d.%d\n ",buff_send[12],buff_send[13],buff_send[14],buff_send[15],buff_send[16],buff_send[17],buff_send[18],buff_send[19]);
			else				
				printf(" : \t%d.%d.%d.%d\t%d.%d.%d.%d\n ",buff_send[12],buff_send[13],buff_send[14],buff_send[15],buff_send[16],buff_send[17],buff_send[18],buff_send[19]);
			}
	} ;
	// 
	close(send_socket);
    }
fclose(fp);
    return 0;
}
